// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "test_tree_grid_idea.h"
#include "ChildView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

IMPLEMENT_DYNCREATE( CChildView, CExtPPVW < CExtTreeGridWnd > );

CChildView::CChildView()
	: m_htiRemembered( NULL )
{
}

CChildView::~CChildView()
{
}

BEGIN_MESSAGE_MAP( CChildView, CExtPPVW < CExtTreeGridWnd > )
	//{{AFX_MSG_MAP(CChildView)
	ON_COMMAND(ID_TREE_ADD_SIBLING_BEFORE, OnTreeAddSiblingBefore)
	ON_UPDATE_COMMAND_UI(ID_TREE_ADD_SIBLING_BEFORE, OnUpdateTreeAddSiblingBefore)
	ON_COMMAND(ID_TREE_ADD_SIBLING_AFTER, OnTreeAddSiblingAfter)
	ON_UPDATE_COMMAND_UI(ID_TREE_ADD_SIBLING_AFTER, OnUpdateTreeAddSiblingAfter)
	ON_COMMAND(ID_TREE_ADD_CHILD_FIRST, OnTreeAddChildFirst)
	ON_UPDATE_COMMAND_UI(ID_TREE_ADD_CHILD_FIRST, OnUpdateTreeAddChildFirst)
	ON_COMMAND(ID_TREE_ADD_CHILD_LAST, OnTreeAddChildLast)
	ON_UPDATE_COMMAND_UI(ID_TREE_ADD_CHILD_LAST, OnUpdateTreeAddChildLast)
	ON_COMMAND(ID_TREE_DELETE_FOCUSED, OnTreeDeleteFocused)
	ON_UPDATE_COMMAND_UI(ID_TREE_DELETE_FOCUSED, OnUpdateTreeDeleteFocused)
	ON_WM_CREATE()
	ON_COMMAND(ID_TREE_DELETE_FOCUSED_CHILDREN, OnTreeDeleteFocusedChildren)
	ON_UPDATE_COMMAND_UI(ID_TREE_DELETE_FOCUSED_CHILDREN, OnUpdateTreeDeleteFocusedChildren)
	ON_COMMAND(ID_TREE_DELETE_ROOTS_CHILDREN, OnTreeDeleteRootsChildren)
	ON_UPDATE_COMMAND_UI(ID_TREE_DELETE_ROOTS_CHILDREN, OnUpdateTreeDeleteRootsChildren)
	ON_COMMAND(ID_TREE_DELETE_FOCUSED_PARENT_CHILDREN, OnTreeDeleteFocusedParentChildren)
	ON_UPDATE_COMMAND_UI(ID_TREE_DELETE_FOCUSED_PARENT_CHILDREN, OnUpdateTreeDeleteFocusedParentChildren)
	ON_COMMAND(ID_TREE_DELETE_FOCUSED_PARENT, OnTreeDeleteFocusedParent)
	ON_UPDATE_COMMAND_UI(ID_TREE_DELETE_FOCUSED_PARENT, OnUpdateTreeDeleteFocusedParent)
	ON_COMMAND(ID_TREE_ADD_ROOT_CHILD_FIRST, OnTreeAddRootChildFirst)
	ON_COMMAND(ID_TREE_ADD_ROOT_CHILD_LAST, OnTreeAddRootChildLast)
	ON_COMMAND(ID_TREE_FOCUS_EXPAND, OnTreeFocusExpand)
	ON_UPDATE_COMMAND_UI(ID_TREE_FOCUS_EXPAND, OnUpdateTreeFocusExpand)
	ON_COMMAND(ID_TREE_FOCUS_COLLAPSE, OnTreeFocusCollapse)
	ON_UPDATE_COMMAND_UI(ID_TREE_FOCUS_COLLAPSE, OnUpdateTreeFocusCollapse)
	ON_COMMAND(ID_TREE_FOCUS_TOGGLE, OnTreeFocusToggle)
	ON_UPDATE_COMMAND_UI(ID_TREE_FOCUS_TOGGLE, OnUpdateTreeFocusToggle)
	ON_COMMAND(ID_TREE_REM_EXPAND, OnTreeRemExpand)
	ON_UPDATE_COMMAND_UI(ID_TREE_REM_EXPAND, OnUpdateTreeRemExpand)
	ON_COMMAND(ID_TREE_REM_COLLAPSE, OnTreeRemCollapse)
	ON_UPDATE_COMMAND_UI(ID_TREE_REM_COLLAPSE, OnUpdateTreeRemCollapse)
	ON_COMMAND(ID_TREE_REM_TOGGLE, OnTreeRemToggle)
	ON_UPDATE_COMMAND_UI(ID_TREE_REM_TOGGLE, OnUpdateTreeRemToggle)
	ON_COMMAND(ID_REMEMBER_ADD, OnRememberAdd)
	ON_UPDATE_COMMAND_UI(ID_REMEMBER_ADD, OnUpdateRememberAdd)
	ON_COMMAND(ID_REMEMBER_REMOVE, OnRememberRemove)
	ON_UPDATE_COMMAND_UI(ID_REMEMBER_REMOVE, OnUpdateRememberRemove)
	//}}AFX_MSG_MAP
	ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()

void CChildView::PreSubclassWindow() 
{
	CExtPPVW < CExtTreeGridWnd >::PreSubclassWindow();

	SiwModifyStyle(
		__EGBS_FIXED_SIZE_ROWS|// ADDED
		__ESIS_STH_PIXEL|__ESIS_STV_ITEM
			|__EGBS_SFB_FULL_ROWS
			|__EGBS_GRIDLINES
			|__EGBS_RESIZING_CELLS_OUTER_H|__EGBS_RESIZING_CELLS_INNER_H|__EGBS_DYNAMIC_RESIZING_H
			//|__EGBS_RESIZING_CELLS_OUTER_V|__EGBS_RESIZING_CELLS_INNER_V|__EGBS_DYNAMIC_RESIZING_V
		,
		0,
		false
		);
	SiwModifyStyleEx(
		__EGBS_EX_CELL_TOOLTIPS_OUTER|__EGBS_EX_CELL_EXPANDING_INNER,
		0,
		false
		);



	BseModifyStyle(__EGWS_BSE_SORT_COLUMNS,0);
	BseModifyStyleEx(__EGBS_BSE_EX_DRAG_COLUMNS
				|__EGBS_BSE_EX_HIGHLIGHT_PRESSING_COLUMNS_OUTER
				|__EGBS_BSE_EX_HIGHLIGHT_PRESSING_STAY_COLUMNS,
				__EGWS_BSE_EX_DEFAULT,false); 

	ColumnInsert( 0, 3 );
	OuterColumnCountLeftSet( 1 );
	OuterColumnCountRightSet( 1 );
	OuterColumnWidthSet( true, 0, 20 );
	OuterColumnWidthSet( false, 0, 20 );
	OuterRowCountTopSet( 1 );
	OuterRowCountBottomSet( 1 );


//	HTREEITEM item = ItemInsert( NULL, ULONG(-1), 1 );



//	ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 );
//	ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 );
//	ItemInsert( ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 );
//	ItemInsert( ItemInsert( ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 );
//	ItemInsert( ItemInsert( ItemInsert( ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 );
//	ItemInsert( NULL, ULONG(-1), 1 );

//	ItemInsert( NULL, ULONG(-1), 3 );
//	ItemInsert( ItemInsert( NULL, ULONG(-1), 2 ), ULONG(-1), 2 );
//	ItemInsert( ItemInsert( NULL, ULONG(-1), 3 ), ULONG(-1), 3 );
//	ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 3 ), ULONG(-1), 3 ), ULONG(-1), 3 );
//	ItemInsert( ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 3 ), ULONG(-1), 3 ), ULONG(-1), 3 ), ULONG(-1), 3 );

//	ItemInsert( ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 3 ), ULONG(-1), 3 ), ULONG(-1), 3 );
//	ItemInsert( ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 );
//	ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 );
	HTREEITEM it = ItemInsert( NULL, ULONG(-1), 1 );

//	ItemInsert( NULL, ULONG(-1), 1 );
//	ItemInsert( NULL, 0, 1 );
//	ItemInsert( NULL, ULONG(-1), 2 );

///	ItemInsert( ItemInsert( ItemInsert( ItemInsert( ItemInsert( ItemInsert( NULL, ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 ), ULONG(-1), 1 );

//return;
CExtGridCell * pCellHdr = GridCellGetOuterAtTop( 0, 0, RUNTIME_CLASS(CExtGridCellHeader) );
	pCellHdr->ExtentSet( 200 );
	pCellHdr->ExtentSet( 1, -1 );
	GridCellGetOuterAtTop( 1, 0, RUNTIME_CLASS(CExtGridCellHeader) );
	GridCellGetOuterAtTop( 2, 0, RUNTIME_CLASS(CExtGridCellHeader) );




	CExtGridCellNumber *item;
	CExtGridCellString *str;
	str = (CExtGridCellString *)ItemGetCell(it,0,0,RUNTIME_CLASS(CExtGridCellString));
	str->TextSet("aaaa ss");

	item = (CExtGridCellNumber *)ItemGetCell(it,1,0,RUNTIME_CLASS(CExtGridCellNumber));
	item->_VariantAssign(313);

	it = ItemInsert(it);
	str = (CExtGridCellString *)ItemGetCell(it,0,0,RUNTIME_CLASS(CExtGridCellString));
	str->TextSet("ss");

	it = ItemInsert( NULL, ULONG(-1), 1 );
	str = (CExtGridCellString *)ItemGetCell(it,0,0,RUNTIME_CLASS(CExtGridCellString));
	str->TextSet("aaaa");
	item = (CExtGridCellNumber *)ItemGetCell(it,1,0,RUNTIME_CLASS(CExtGridCellNumber));
	item->_VariantAssign(98);

	it = ItemInsert(it);
	str = (CExtGridCellString *)ItemGetCell(it,0,0,RUNTIME_CLASS(CExtGridCellString));
	str->TextSet("ss");

	HTREEITEM iit = ItemGetFirstChild(ItemGetRoot());
	for (; iit != NULL; iit = ItemGetNext(iit,true,false,true))
	{
		ItemHide(iit,true,true);
		ItemHide(iit,false,true);
	}
}

void CChildView::OnTreeAddSiblingBefore() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
HTREEITEM htiParent = ItemGetParent( htiFocus );
	ASSERT( htiParent != NULL );
LONG nSiblingIndex = ItemGetSiblingIndexOf( htiFocus );
HTREEITEM hti = ItemInsert( htiParent, nSiblingIndex );
	ItemFocusSet( hti );
}

void CChildView::OnUpdateTreeAddSiblingBefore(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeAddSiblingAfter() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
HTREEITEM htiParent = ItemGetParent( htiFocus );
	ASSERT( htiParent != NULL );
LONG nSiblingIndex = ItemGetSiblingIndexOf( htiFocus );
HTREEITEM hti = ItemInsert( htiParent, nSiblingIndex + 1 );
	ItemFocusSet( hti );
}

void CChildView::OnUpdateTreeAddSiblingAfter(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeAddChildFirst() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
HTREEITEM hti = ItemInsert( htiFocus, 0 );
	ItemFocusSet( hti );
}

void CChildView::OnUpdateTreeAddChildFirst(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeAddChildLast() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
HTREEITEM hti = ItemInsert( htiFocus );
	ItemFocusSet( hti );
}

void CChildView::OnUpdateTreeAddChildLast(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeDeleteFocused() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
	ItemRemove( htiFocus );
}

void CChildView::OnUpdateTreeDeleteFocused(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeDeleteFocusedChildren() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if(		htiFocus == NULL
		||	ItemGetChildCount( htiFocus ) == 0
		)
		return;
	ItemRemove( htiFocus, true );
}

void CChildView::OnUpdateTreeDeleteFocusedChildren(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if(		htiFocus == NULL
		||	ItemGetFirstChild( htiFocus ) == NULL
//		||	ItemGetChildCount( htiFocus ) == 0
		)
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeDeleteFocusedParent() 
{
HTREEITEM hti = ItemFocusGet();
	if( hti == NULL )
		return;
	hti = ItemGetParent( hti );
	ASSERT( hti != NULL );
	ItemRemove( hti );
}

void CChildView::OnUpdateTreeDeleteFocusedParent(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeDeleteFocusedParentChildren() 
{
HTREEITEM hti = ItemFocusGet();
	if( hti == NULL )
		return;
	hti = ItemGetParent( hti );
	ASSERT( hti != NULL );
	ItemRemove( hti, true );
}

void CChildView::OnUpdateTreeDeleteFocusedParentChildren(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeDeleteRootsChildren() 
{
HTREEITEM hti = ItemGetRoot();
	ASSERT( hti != NULL );
	if( ItemGetChildCount(hti) == 0 )
		return;
	ItemRemove( hti );
}

void CChildView::OnUpdateTreeDeleteRootsChildren(CCmdUI* pCmdUI) 
{
HTREEITEM hti = ItemGetRoot();
	ASSERT( hti != NULL );
	if( ItemGetChildCount(hti) == 0 )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeAddRootChildFirst() 
{
HTREEITEM htiRoot = ItemGetRoot();
	ItemInsert( htiRoot, 0 );
}

void CChildView::OnTreeAddRootChildLast() 
{
HTREEITEM htiRoot = ItemGetRoot();
	ItemInsert( htiRoot );
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CExtPPVW < CExtTreeGridWnd > ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if(		(! m_wndToolBar.Create( NULL, this, AFX_IDW_TOOLBAR ) )
		||	(! m_wndToolBar.LoadToolBar( IDR_TOOLBAR1 ) )
		)
	{
		ASSERT( FALSE );
		return -1;
	}
	
	return 0;
}

void CChildView::OnTreeFocusExpand() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
	if( ItemIsExpanded(htiFocus) )
		return;
	ItemExpand( htiFocus, TVE_EXPAND );
}
void CChildView::OnUpdateTreeFocusExpand(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( ItemIsExpanded(htiFocus) )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeFocusCollapse() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
	if( ! ItemIsExpanded(htiFocus) )
		return;
	ItemExpand( htiFocus, TVE_COLLAPSE );
}
void CChildView::OnUpdateTreeFocusCollapse(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( ! ItemIsExpanded(htiFocus) )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeFocusToggle() 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
		return;
	ItemExpand( htiFocus, TVE_TOGGLE );
}
void CChildView::OnUpdateTreeFocusToggle(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeRemExpand() 
{
	if( m_htiRemembered == NULL )
		return;
	if( ItemIsExpanded(m_htiRemembered) )
		return;
	ItemExpand( m_htiRemembered, TVE_EXPAND );
}
void CChildView::OnUpdateTreeRemExpand(CCmdUI* pCmdUI) 
{
	if( m_htiRemembered == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( ItemIsExpanded(m_htiRemembered) )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeRemCollapse() 
{
	if( m_htiRemembered == NULL )
		return;
	if( ! ItemIsExpanded(m_htiRemembered) )
		return;
	ItemExpand( m_htiRemembered, TVE_COLLAPSE );
}
void CChildView::OnUpdateTreeRemCollapse(CCmdUI* pCmdUI) 
{
	if( m_htiRemembered == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( ! ItemIsExpanded(m_htiRemembered) )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnTreeRemToggle() 
{
	if( m_htiRemembered == NULL )
		return;
	ItemExpand( m_htiRemembered, TVE_TOGGLE );
}
void CChildView::OnUpdateTreeRemToggle(CCmdUI* pCmdUI) 
{
	if( m_htiRemembered == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnRememberAdd() 
{
	m_htiRemembered = ItemFocusGet();	
}
void CChildView::OnUpdateRememberAdd(CCmdUI* pCmdUI) 
{
HTREEITEM htiFocus = ItemFocusGet();
	if( htiFocus == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnRememberRemove() 
{
	m_htiRemembered = NULL;
}
void CChildView::OnUpdateRememberRemove(CCmdUI* pCmdUI) 
{
	if( m_htiRemembered == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable();
}

void CChildView::OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/)
{
	const CExtGridHitTestInfo &hi = HoverInfoGet();

	if (hi.m_dwAreaFlags == __EGBWA_NOWHERE)
		AfxMessageBox("NOWHERE!");
}
