// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__87DAF796_55E1_4656_9D21_C00403833474__INCLUDED_)
#define AFX_CHILDVIEW_H__87DAF796_55E1_4656_9D21_C00403833474__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CChildView window

class CChildView : public CExtPPVW < CExtTreeGridWnd >
{
	HTREEITEM m_htiRemembered;
public:
	DECLARE_DYNCREATE( CChildView );
	CChildView();
	virtual ~CChildView();

	CExtToolControlBar m_wndToolBar;

	//{{AFX_VIRTUAL(CChildView)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CChildView)
	afx_msg void OnTreeAddSiblingBefore();
	afx_msg void OnUpdateTreeAddSiblingBefore(CCmdUI* pCmdUI);
	afx_msg void OnTreeAddSiblingAfter();
	afx_msg void OnUpdateTreeAddSiblingAfter(CCmdUI* pCmdUI);
	afx_msg void OnTreeAddChildFirst();
	afx_msg void OnUpdateTreeAddChildFirst(CCmdUI* pCmdUI);
	afx_msg void OnTreeAddChildLast();
	afx_msg void OnUpdateTreeAddChildLast(CCmdUI* pCmdUI);
	afx_msg void OnTreeDeleteFocused();
	afx_msg void OnUpdateTreeDeleteFocused(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTreeDeleteFocusedChildren();
	afx_msg void OnUpdateTreeDeleteFocusedChildren(CCmdUI* pCmdUI);
	afx_msg void OnTreeDeleteRootsChildren();
	afx_msg void OnUpdateTreeDeleteRootsChildren(CCmdUI* pCmdUI);
	afx_msg void OnTreeDeleteFocusedParentChildren();
	afx_msg void OnUpdateTreeDeleteFocusedParentChildren(CCmdUI* pCmdUI);
	afx_msg void OnTreeDeleteFocusedParent();
	afx_msg void OnUpdateTreeDeleteFocusedParent(CCmdUI* pCmdUI);
	afx_msg void OnTreeAddRootChildFirst();
	afx_msg void OnTreeAddRootChildLast();
	afx_msg void OnTreeFocusExpand();
	afx_msg void OnUpdateTreeFocusExpand(CCmdUI* pCmdUI);
	afx_msg void OnTreeFocusCollapse();
	afx_msg void OnUpdateTreeFocusCollapse(CCmdUI* pCmdUI);
	afx_msg void OnTreeFocusToggle();
	afx_msg void OnUpdateTreeFocusToggle(CCmdUI* pCmdUI);
	afx_msg void OnTreeRemExpand();
	afx_msg void OnUpdateTreeRemExpand(CCmdUI* pCmdUI);
	afx_msg void OnTreeRemCollapse();
	afx_msg void OnUpdateTreeRemCollapse(CCmdUI* pCmdUI);
	afx_msg void OnTreeRemToggle();
	afx_msg void OnUpdateTreeRemToggle(CCmdUI* pCmdUI);
	afx_msg void OnRememberAdd();
	afx_msg void OnUpdateRememberAdd(CCmdUI* pCmdUI);
	afx_msg void OnRememberRemove();
	afx_msg void OnUpdateRememberRemove(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
}; // class CChildView

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__87DAF796_55E1_4656_9D21_C00403833474__INCLUDED_)
